<?php include_once('../setlang.inc.php'); ?>

<style>
  .noarrow>a:after {
    display: none !important;
  }
  .dropdown-toggle:hover { text-decoration: none; }
</style>

<script>

  $(document).ready(function() {
    window.onclick = function(e) {
        if (!e.target.matches('#report-dropdown-button')) {
            var report = $('#report-dropdown');
            if (report.is(":visible")) {
                report.toggle();
            }
        }
        if (!e.target.matches('#save-dropdown-button')) {
            var save = $('#save-dropdown');
            if (save.is(":visible")) {
                save.toggle();
            }
        }
    }

    $('#report-dropdown-button').on('click', function(e) {
        $('#report-dropdown').toggle();
        var save = $('#save-dropdown');
        if (save.is(":visible")) {
            save.toggle();
        }
    });

    $('#save-dropdown-button').on('click', function(e) {
        $('#save-dropdown').toggle();
        var report = $('#report-dropdown');
        if (report.is(":visible")) {
            report.toggle();
        }
    });
  });

</script>

<div class="well bg" style="margin-bottom: 0;">
    <div class="container-fluid" style="padding: 0;">
        <div class="row" style="margin: 0 -10px;">
            <div class="col-sm-4">
                <h2 style="padding: 0; line-height: 29px;">
                    <i ng-show="dashboard.current.edit_type != 'global' && dashboard.current.edit_type != 'system' && dashboard.current.report != true" style="margin-right: 10px; font-size: 15px; vertical-align: middle;" class="fa fa-desktop" bs-tooltip="'<?php echo _('This is a dashboard'); ?>'"></i>
                    <i ng-show="dashboard.current.edit_type == 'global' && dashboard.current.edit_type != 'system'" style="margin-right: 10px; font-size: 15px; vertical-align: middle;" class="fa fa-globe" title="This is a global dashboard"></i> 
                    <text id="dashboard-title">{{dashboard.current.title}}</text>
                    <a ng-show="dashboard.current.report != true" class="dropdown-toggle btn btn-xs btn-default" ng-click="fullscreen()" style="vertical-align: top; margin-left: 10px; margin-top: 3px;" data-placement="right" bs-tooltip="'<?php echo _('Toggle Fullscreen'); ?>'">
                        <i class='fa fa-arrows-alt atn00' style="margin: 0; font-size: 13px;"></i>
                    </a>
                </h2>
            </div>
            <div id="dashboard-ctrl" class="col-sm-8 no-print" style="text-align: right;" ng-show="dashboard.current.report != true">
                <div class="nls-pulldown" style="display: inline-block; vertical-align: top; margin-right: 15px;">
                    <div ng-repeat="pulldown in dashboard.current.nav" ng-controller="PulldownCtrl" ng-show="pulldown.enable">
                        <kibana-simple-panel type="pulldown.type" ng-cloak></kibana-simple-panel>
                    </div>
                </div>
                <div class="dash-btn">
                    <div ng-show="dashboard.current.loader.home != false">
                        <button class="btn btn-sm btn-default" bs-tooltip="'<?php echo _('Goto saved default'); ?>'" data-placement="bottom" onclick="window.location='dashboard#'">
                            <i class='fa fa-home'></i>
                        </button>
                    </div>
                </div>
                <div class="dash-btn">
                    <div ng-show="dashboard.current.queriesmanager != false" bs-tooltip="'<?php echo _('Manage queries'); ?>'" data-placement="bottom">
                        <button class="btn btn-sm btn-default" config-modal="app/partials/managequeries.php" kbn-model="dashboard">
                            <i class="fa fa-search"></i>
                        </button>
                    </div>
                </div>
                <div class="dash-btn">
                    <div ng-show="dashboard.current.buttonsmanager != false" bs-tooltip="'<?php echo _('Manage easy buttons'); ?>'" data-placement="bottom">
                        <button class="btn btn-sm btn-default" config-modal="app/partials/managebuttons.php" kbn-model="dashboard">
                            <i class="fa fa-th-large"></i>
                        </button>
                    </div>
                </div>
                <div class="dash-btn" ng-show="dashboard.current.alertable != false && alert_perms() == 1">
                    <div bs-tooltip="'<?php echo _('Create an alert'); ?>'" data-placement="bottom">
                        <button class="btn btn-sm btn-default" config-modal="app/partials/alerteditor.php" kbn-model="dashboard">
                            <i class="fa fa-bell"></i>
                        </button>
                    </div>
                </div>
                <div class="dash-btn">
                    <div class="dropdown" ng-show="showDropdown('load')">
                        <button bs-tooltip="'<?php echo _('Load'); ?>'" data-placement="bottom" class="btn btn-sm btn-default dropdown-toggle" data-toggle="dropdown" ng-click="elasticsearch_dblist('title:'+elasticsearch.query+'*')">
                            <i class='fa fa-folder-open' style="margin: 0;"></i>
                        </button>
                        <ul class="dropdown-menu" style="padding:10px; width: 320px; margin-left: -285px;">
                            <li ng-if='dashboard.current.loader.load_elasticsearch != false'>
                                <form class="nomargin">
                                    <input type="text" class="form-control" ng-model="elasticsearch.query" ng-change="elasticsearch_dblist('title:'+elasticsearch.query+'*')" placeholder="<?php echo _('Type to filter'); ?>" style="width: 100%;">
                                </form>
                                <table class="table table-condensed table-border table-striped kibana-load" style="margin: 10px 0;">
                                    <tr ng-hide="elasticsearch.dashboards.length">
                                        <td><?php echo _('No dashboards matching your query found'); ?></td>
                                    </tr>
                                    <tr bindonce ng-repeat="row in elasticsearch.dashboards | orderBy:['_source.title']">
                                        <td>
                                            <i ng-show="row._source.user == 'global'" class="fa fa-globe"></i>
                                            <a href="dashboard#/dashboard/elasticsearch/{{row._id}}" bo-text="row._source.title"></a>
                                        </td>
                                        <td style="width: 12px; text-align: center;">
                                            <a ng-show="(row._source.user != 'global' || admin_perms() == 1) && dashboard.current.dash_type == 'elasticsearch' && (row._id != 'guided' && row._id != 'default' && row._id != 'blank')" confirm-click="elasticsearch_delete(row._id, 'dashboard')" confirmation="<?php echo _('Are you sure you want to delete the'); ?> {{row._source.title}} <?php echo _('dashboard'); ?>"><i class="fa fa-remove"></i></a>
                                        </td>
                                    </tr>
                                </table>
                            </li>
                            <li class="dropdown-submenu noarrow">
                                <a tabindex="-1" class="small" style="padding: 3px 0;"><i class="fa fa-caret-left"></i> <?php echo _('Advanced'); ?></a>
                                <ul class="dropdown-menu" style="top: 0; left: -100%; padding: 20px;">
                                    <li>
                                        <h5 style="margin-top: 0; padding-top: 0;"><?php echo _('Import dashboard from file'); ?> <tip><?php echo _('Load an exported dashboard in JSON layout from file'); ?></tip></h5>
                                        <form>
                                            <input type="file" id="dashupload" dash-upload /><br>
                                        </form>
                                    </li>
                                    <li style="width: 100%;">
                                        <h5><?php echo _('Gist'); ?> <tip><?php echo _('Enter a gist number or url'); ?></tip></h5>
                                        <form>
                                            <input type="text" ng-model="gist.url" class="form-control" stlye="width: 100%;" placeholder="<?php echo _("Gist number or URL"); ?>"><br>
                                            <button class="btn btn-sm btn-default" style="margin-top: 5px;" ng-click="gist_dblist(dashboard.gist_id(gist.url))" ng-show="dashboard.is_gist(gist.url)"><i class="fa fa-github-alt"></i> <?php echo _('Get gist'); ?>:{{gist.url | gistid}}</button>
                                            <h6 ng-show="gist.files.length"><?php echo _('Dashboards in gist'); ?>:{{gist.url | gistid}} <small><?php echo _('click to load'); ?></small></h6>
                                            <h6 ng-hide="gist.files.length || !gist.url.length"><?php echo _('No gist dashboards found'); ?></h6>
                                            <table class="table table-condensed table-striped">
                                                <tr ng-repeat="file in gist.files">
                                                    <td><a ng-click="dashboard.dash_load(file, 'elasticsearch')">{{file.title}}</a></td>
                                                </tr>
                                            </table>
                                        </form>
                                    </li>
                                </ul>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="dash-btn">
                    <div class="dropdown" ng-show="showDropdown('save')">
                        <div class="btn-group" id="save-dash-div" bs-tooltip="'<?php echo _('Save'); ?>'" data-placement="bottom" data-container="body">
                            <button id="save-dash-button" class="btn btn-sm btn-success" ng-click="elasticsearch_save('save', false, true)" ng-show="dashboard.current.dash_type == 'elasticsearch' && (dashboard.current.edit_type != 'global' || admin_perms() == 1) && dashboard.current.edit_type != 'system' && dashboard.imported != 1"><i class="fa fa-floppy-o"></i></button>
                            <button class="btn btn-sm btn-default" disabled ng-show="dashboard.current.dash_type != 'elasticsearch' || (dashboard.current.edit_type == 'global' && admin_perms() == 0) || dashboard.current.edit_type == 'system' || dashboard.imported == 1"><i class="fa fa-floppy-o"></i></button>
                            <button id="save-dropdown-button" class="btn btn-sm btn-default dropdown-toggle" data-placement="bottom" data-toggle="dropdown">
                                <i class="fa fa-caret-down" style="margin: 0;"></i>
                            </button>
                        </div>
                        <ul id="save-dropdown" class="dropdown-menu pull-right" style="padding: 10px; width: 302px;">
                            <li ng-show="dashboard.current.loader.save_elasticsearch != false" style="margin-bottom: 10px;">
                                <form class="input-append nomargin" name="saveas">
                                    <input class='form-control' type="text" ng-model="elasticsearch.title" placeholder="<?php echo _("Save as..."); ?>" style="width: 160px;">
                                    <button class="btn btn-sm btn-default" bs-tooltip="'<?php echo _('Save as dashboard'); ?>...'" ng-show="dashboard.current.dash_type == 'elasticsearch' || dashboard.current.dash_type == 'file'" ng-click="elasticsearch_save('dashboard')"><i class="fa fa-sign-in" style="font-size: 15px; vertical-align: middle;"></i></button>
                                    <button class="btn btn-sm btn-default" bs-tooltip="'<?php echo _('Save as global dashboard'); ?>...'" ng-show="admin_perms() == 1 && (dashboard.current.dash_type == 'elasticsearch' || dashboard.current.dash_type == 'file')" ng-click="elasticsearch_save('global-dashboard')"><i class="fa fa-globe" style="font-size: 15px; vertical-align: middle;"></i> <i class="fa fa-sign-in" style="font-size: 15px; vertical-align: middle;"></i></button>
                                </form>
                            </li>
                            <li class="dropdown-submenu noarrow">
                                <a tabindex="-1" class="small" style="padding: 3px 0;"><i class="fa fa-caret-left"></i> <?php echo _('Advanced'); ?></a>
                                <ul class="dropdown-menu" style="top: 0; left: -100%;"">
                                    <li>
                                        <a class="link" ng-click="set_default()"><?php echo _('Set as Default Dashboard'); ?></a>
                                    </li>
                                    <li>
                                        <a class="link" ng-click="dashboard.to_file()"><?php echo _('Export Dashboard'); ?>...</a>
                                    </li>
                                </ul>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="dash-btn">
                    <div class="dropdown" ng-show="showDropdown('report')">
                        <div class="btn-group" bs-tooltip="'<?php echo _('Save as Report'); ?>'" data-placement="bottom" data-container="body">
                            <button id="save-dash-button" class="btn btn-sm btn-default" ng-click="elasticsearch_save('report')" ng-show="dashboard.imported != 1"><i class="fa fa-file-text-o"></i></button>
                            <button class="btn btn-sm btn-default" disabled ng-show="dashboard.imported == 1"><i class="fa fa-file-text-o"></i></button>
                            <button id="report-dropdown-button" class="btn btn-sm btn-default dropdown-toggle" data-placement="bottom" data-toggle="dropdown">
                                <i class="fa fa-caret-down" style="margin: 0;"></i>
                            </button>
                        </div>
                        <ul id="report-dropdown" class="dropdown-menu pull-right" style="padding: 10px; width: 302px;">
                            <li ng-show="dashboard.current.loader.save_elasticsearch != false">
                                <form class="input-append nomargin" name="saveas">
                                    <input class='form-control' type="text" ng-model="elasticsearch.title" placeholder="<?php echo _("Save as..."); ?>" style="width: 160px;">
                                    <button class="btn btn-sm btn-default" bs-tooltip="'<?php echo _('Save as report'); ?>...'" ng-show="dashboard.current.dash_type == 'elasticsearch' || dashboard.current.dash_type == 'file'" ng-click="elasticsearch_save('report')"><i class="fa fa-sign-in" style="font-size: 15px; vertical-align: middle;"></i></button>
                                    <button class="btn btn-sm btn-default" bs-tooltip="'<?php echo _('Save as global report'); ?>...'" ng-show="admin_perms() == 1 && (dashboard.current.dash_type == 'elasticsearch' || dashboard.current.dash_type == 'file')" ng-click="elasticsearch_save('global-report')"><i class="fa fa-globe" style="font-size: 15px; vertical-align: middle;"></i> <i class="fa fa-sign-in" style="font-size: 15px; vertical-align: middle;"></i></button>
                                </form>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="dash-btn">
                    <div ng-show="showDropdown('share')">
                        <button class="btn btn-sm btn-default" bs-tooltip="'<?php echo _('Share'); ?>'" data-placement="bottom" ng-click="elasticsearch_save('temp',dashboard.current.loader.save_temp_ttl)" bs-modal="'app/partials/dashLoaderShare.php'">
                            <i class='fa fa-share'></i>
                        </button>
                    </div>
                </div>
                <div class="dash-btn">
                    <div ng-show="dashboard.current.editable" bs-tooltip="'<?php echo _('Configure dashboard'); ?>'" data-placement="bottom">
                        <button class="btn btn-sm btn-default" config-modal="app/partials/dasheditor.php" kbn-model="dashboard">
                            <i class='fa fa-cog'></i>
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
