<?php include_once('../setlang.inc.php'); ?>

<div class="top-row" ng-repeat="pulldown in dashboard.current.pulldowns" ng-controller="PulldownCtrl" ng-show="pulldown.enable && dashboard.current.report != true" style="margin-top: 20px;">
    <div class="top-row-close pointer pull-left" ng-class="pulldownTabStyle($index)" ng-click="toggle_pulldown(pulldown);dismiss();" bs-tooltip="'<?php echo _('Toggle'); ?> '+lang(pulldown.type)" data-placement="bottom">
        <span class="small">{{lang(pulldown.type)}}</span>
        <i class="small fa" ng-class="{'fa-caret-left':pulldown.collapse,'fa-caret-right':!pulldown.collapse}"></i>
        <i class="small fa fa-star" ng-show="row.notice && pulldown.collapse"></i>
    </div>
    <div class="clearfix bgNav" ng-hide="pulldown.collapse"></div>
    <div class="top-row-open" ng-hide="pulldown.collapse">
        <kibana-simple-panel type="pulldown.type" ng-cloak></kibana-simple-panel>
    </div>
</div>
<div class="clearfix bgNav"></div>
<div class="container-fluid main" style="padding: 5px 0 0 0;">
    <div>
        <div class="kibana-container container">

            <!-- Rows -->
            <div class="kibana-row" ng-controller="RowCtrl" ng-repeat="(row_name, row) in dashboard.current.rows" ng-style="row_style(row)">
                <div class="row-control">

                    <div style="padding: 0px; margin: 0px; position: relative;" ng-show="dashboard.current.report != true">
                        <div class="row-close" ng-show="row.collapse" data-placement="bottom" >
                            <span class="row-button bg-light-green" config-modal="app/partials/roweditor.php" kbn-model="row" class="pointer">
                                <i bs-tooltip="'Configure row'" data-placement="right" ng-show="row.editable" class="fa fa-cog pointer"></i>
                            </span>
                            <span class="row-button bg-green" ng-click="toggle_row(row)" ng-show="row.collapsable">
                                <i bs-tooltip="'Expand row'" data-placement="right" ng-show="row.collapsable" class="fa fa-caret-left pointer" ></i>
                            </span>
                            <span class="row-button row-text" ng-click="toggle_row(row)" ng-class="{'pointer':row.collapsable}">{{row.title || 'Row '+$index}}</span>
                        </div>
                        <div style="text-align:center" class="row-open" ng-show="!row.collapse">
                            <div ng-show="row.collapsable" class='row-tab bg-green' ng-click="toggle_row(row)">
                                <i bs-tooltip="'<?php echo _('Collapse row'); ?>'" data-placement="right"  class="fa fa-caret-right" ></i>
                            </div>
                            <div config-modal="app/partials/roweditor.php" kbn-model="row" class='row-tab bg-light-green' ng-show="row.editable">
                                <i bs-tooltip="'<?php echo _('Configure row'); ?>'" data-placement="right"  class="fa fa-cog pointer"></i>
                            </div>
                            <div class="row-tab bg-dark-green" ng-click="editor.index = 2" config-modal="app/partials/roweditor.php" kbn-model="row" ng-show="row.editable">
                                <i class="fa fa-plus" bs-tooltip="'<?php echo _('Add Panel'); ?>'" data-placement="right"></i>
                            </div>
                        </div>
                    </div>

                    <div style="padding-top: 0px; display: table; width: 100%;" ng-if="!row.collapse">

                        <!-- All the panels in the row -->
                        <div
                          ng-repeat="(name, panel) in row.panels|filter:isPanel"
                          ng-cloak ng-hide="panel.hide"
                          kibana-panel type='panel.type' resizable
                          class="panel nospace" ng-class="{'dragInProgress':dashboard.panelDragging}"
                          style="position:relative"  ng-style="{'width':!panel.span?'100%':((panel.span/1.2)*10)+'%'}"
                          data-drop="true" ng-model="row.panels" data-jqyoui-options
                          jqyoui-droppable="{index:$index,mutate:false,onDrop:'panelMoveDrop',onOver:'panelMoveOver(true)',onOut:'panelMoveOut'}">
                        </div>

                        <!-- A suggestion filler panel that appears when a panel is being dragged, but there is no panels in the row to drop it on -->
                        <div ng-show="dashboard.panelDragging && row.panels.length == 0" class="panel panel-filler" ng-class="{'dragInProgress':dashboard.panelDragging}" ng-style="{height:row.height}" data-drop="true" ng-model="row.panels" data-jqyoui-options jqyoui-droppable="{index:row.panels.length,mutate:false,onDrop:'panelMoveDrop',onOver:'panelMoveOver',onOut:'panelMoveOut'}">
                            <h1><?php echo _('Drop here to add to this row'); ?></h1>
                            <?php echo _('Or drop on top of any other panel to insert in that row'); ?>
                        </div>

                        <span config-modal="app/partials/roweditor.php" kbn-model="row" ng-show="row.editable && !dashboard.panelDragging">
                            <span ng-click="editor.index = 2" style="margin-top: 3px; margin-left: 5px" ng-show="row.panels.length==0" class="btn btn-sm btn-default"><?php echo _('Add panel to empty row'); ?></span>
                        </span>

                        <div class="clearfix"></div>
                    </div>

                </div>
            </div>

            <div class="row-fluid" ng-show='dashboard.current.editable && dashboard.current.report != true'>
                <div class="span12" style="text-align:right;">
                    <span class="pointer row-add-button" style="margin: 10px 15px 15px 0; display: inline-block;" config-modal="app/partials/dasheditor.php" kbn-model="dashboard">
                        <span ng-click="editor.index = 2"><i class="fa fa-plus"></i> <?php echo _('ADD A ROW'); ?></span>
                    </span>
                </div>
            </div>

        </div>
    </div>
</div>
